function [f] = diffusion_corner(f0,a,b,D,dx,dt)
%DIFFUSION_CONER produces the diffusion of matter at the corner;
%Output:the diffusion result of the 3X3 corner;
%Input:
%f0:the 3X3 corner matrix of last iteration
%a:the compelete matrix
%b:input concentration at the corner
%D:diffusition coefficient
%dx:every split size
%dt:;loop delta time in s

f=f0;
f0(3,3)=a(3,3);
f0(1,1)=b;
D=D/3;

f(1,1)=f0(1,1)+dt*D*(1/dx^2)*(f0(2,1)+f0(1,2)-2*f0(1,1));
f(1,2)=f0(1,2)+dt*D*(1/dx^2)*(f0(2,2)+f0(1,1)-2*f0(1,2));
f(3,3)=f0(3,3)+dt*D*(1/dx^2)*(f0(2,3)+f0(3,2)-2*f0(3,3));
f(3,2)=f0(3,2)+dt*D*(1/dx^2)*(f0(2,2)+f0(3,3)-2*f0(3,2));
f(2,1)=f0(2,1)+dt*D*(1/dx^2)*(f0(1,1)+f0(2,2)-2*f0(2,1));
f(2,3)=f0(2,3)+dt*D*(1/dx^2)*(f0(3,3)+f0(2,2)-2*f0(2,3));
f(2,2)=f0(2,2)+dt*D*(1/dx^2)*(f0(2,1)+f0(1,2)+f0(3,2)+f0(2,3)-4*f0(2,2));
f(1,3)=f0(1,3);
f(3,1)=f0(3,1);

end

