function [y1t,y2t]=push_fun(My1,My2,y1,y2,dt)
%DIFFUSION_FUN produces the diffusion of matter;
%Output:the number and distribution of Y1 and Y2;
%Input:
%My2:amount of change of Y1
%My1:amount of change of Y2
%y1:the number and distribution of Y1 before calculation
%y2:the number and distribution of Y2 before calculation
%dt:loop delta time in s
[m,n]=size(y1);

y1t = y1;
y2t = y2;
f0=y1+y2;

dayu10_1=find(My1>0);
dayu10_2=dayu10_1(rem(dayu10_1,m)>1);
dayu10_3=dayu10_2(1<ceil(dayu10_2/m));
dayu10=dayu10_3(ceil(dayu10_3/m)<m);
xiaoyu01=find(My1<0);
num1=My1.*dt;
dayu20_1=find(My2>0);
dayu20_2=dayu20_1(rem(dayu20_1,m)>1);
dayu20_3=dayu20_2(1<ceil(dayu20_2/m));
dayu20=dayu20_3(ceil(dayu20_3/m)<m);
xiaoyu02=find(My2<0);
num2=My2.*dt;

prob1=100./(f0+100);
prob = 1-prob1;


xu=zeros(m,n);
xl=zeros(m,n);
xr=zeros(m,n);
xd=zeros(m,n);
sumx=zeros(m,n);
xu(2:m-1,2:n-1)=f0(2:m-1,2:n-1)-f0(1:m-2,2:n-1);
xl(2:m-1,2:n-1)=f0(2:m-1,2:n-1)-f0(2:m-1,1:n-2);
xr(2:m-1,2:n-1)=f0(2:m-1,2:n-1)-f0(2:m-1,3:n);
xd(2:m-1,2:n-1)=f0(2:m-1,2:n-1)-f0(3:m,2:n-1);
xu(xu<0)=0;
xl(xl<0)=0;
xr(xr<0)=0;
xd(xd<0)=0;
sumx(2:m-1,2:n-1)=xu(2:m-1,2:n-1)+xl(2:m-1,2:n-1)+xr(2:m-1,2:n-1)+xd(2:m-1,2:n-1);
grow1=num1.*prob./sumx;
grow2=num2.*prob./sumx;


if exist ('dayu10','var') && exist ('dayu20','var')
    [a b]=ismember(dayu10,dayu20);
    dayu0=dayu10(a==1);
    dayu01=dayu10(a==0);
    [c d]=ismember(dayu20,dayu10);
    dayu02=dayu20(c==0);
    
    for i=1:length(dayu0)
        loc=dayu0(i);
        if sumx(loc)>0
            
            y1t(loc+1) = y1t(loc+1)+grow1(loc)*xd(loc);
            y1t(loc-1) = y1t(loc-1)+grow1(loc)*xu(loc);
            y1t(loc+m) = y1t(loc+m)+grow1(loc)*xr(loc);
            y1t(loc-m) = y1t(loc-m)+grow1(loc)*xl(loc);
            y1t(loc) =  y1t(loc)+num1(loc)*prob1(loc);
            
            y2t(loc+1) = y2t(loc+1)+grow2(loc)*xd(loc);
            y2t(loc-1) = y2t(loc-1)+grow2(loc)*xu(loc);
            y2t(loc+m) = y2t(loc+m)+grow2(loc)*xr(loc);
            y2t(loc-m) = y2t(loc-m)+grow2(loc)*xl(loc);
            y2t(loc) =  y2t(loc)+num2(loc)*prob1(loc);
            
        else
            y1t(loc) = y1t(loc)+num1(loc);
            y2t(loc) = y2t(loc)+num2(loc);
        end
        
    end
    if exist ('dayu01','var')
        for i=1:length(dayu01)
            loc=dayu01(i);
            if sumx(loc)>0

                y1t(loc+1) = y1t(loc+1)+grow1(loc)*xd(loc);
                y1t(loc-1) = y1t(loc-1)+grow1(loc)*xu(loc);
                y1t(loc+m) = y1t(loc+m)+grow1(loc)*xr(loc);
                y1t(loc-m) = y1t(loc-m)+grow1(loc)*xl(loc);
                y1t(loc) =  y1t(loc)+num1(loc)*prob1(loc);
            else
                y1t(loc) = y1t(loc)+num1(loc);
                
            end
            
        end
    end
    if exist ('dayu02','var')
        for i=1:length(dayu02)
            loc=dayu02(i);
            
            if sumx(loc)>0
                
                y2t(loc+1) = y2t(loc+1)+grow2(loc)*xd(loc);
                y2t(loc-1) = y2t(loc-1)+grow2(loc)*xu(loc);
                y2t(loc+m) = y2t(loc+m)+grow2(loc)*xr(loc);
                y2t(loc-m) = y2t(loc-m)+grow2(loc)*xl(loc);
                y2t(loc) =  y2t(loc)+num2(loc)*prob1(loc);
                
            else
                
                y2t(loc) = y2t(loc)+num2(loc);
            end
            
        end
    end
elseif exist ('dayu10','var')
    dayu01=dayu10;
    for i=1:length(dayu01)
        loc=dayu01(i);
        if sumx(loc)>0

            
            y1t(loc+1) = y1t(loc+1)+grow1(loc)*xd(loc);
            y1t(loc-1) = y1t(loc-1)+grow1(loc)*xu(loc);
            y1t(loc+m) = y1t(loc+m)+grow1(loc)*xr(loc);
            y1t(loc-m) = y1t(loc-m)+grow1(loc)*xl(loc);
            y1t(loc) =  y1t(loc)+num1(loc)*prob1(loc);
            
        else
            y1t(loc) = y1t(loc)+num1(loc);
            
        end
        
    end
elseif exist ('dayu20','var')
    dayu02=dayu20;
    for i=1:length(dayu02)
        loc=dayu02(i);
        if sumx(loc)>0

            
            y2t(loc+1) = y2t(loc+1)+grow2(loc)*xd(loc);
            y2t(loc-1) = y2t(loc-1)+grow2(loc)*xu(loc);
            y2t(loc+m) = y2t(loc+m)+grow2(loc)*xr(loc);
            y2t(loc-m) = y2t(loc-m)+grow2(loc)*xl(loc);
            y2t(loc) =  y2t(loc)+num2(loc)*prob1(loc);
            
        else
            
            y2t(loc) = y2t(loc)+num2(loc);
        end
        
    end
end

y1t(xiaoyu01) = y1t(xiaoyu01)+num1(xiaoyu01);
y2t(xiaoyu02) = y2t(xiaoyu02)+num2(xiaoyu02);
